<?php
/* SVN FILE: $Id: ruarobot.php 127 2008-02-06 20:51:27Z rick $ */
/*
Plugin Name: RUaRobot? Rus
Plugin URI: http://www.isinc.com/wordpress/ruarobot/
Description: RUARobot плагин для wordpress, позволяющий установить капчу на комментарии. Используется капча 1.0 проекта captcha.ru. UPD: Обновление капчи до версии 2.0 и перевод - Максим Новиков, ishop-abc.ru
Version: 1.0.3
Author: ISInc.
Author URI: http://www.isinc.com
*/
/*  
	Copyright (c) 2008 Rick Crawford <rick_crawford@hotmail.com>
	All rights reserved.

	Please read the LICENSE file for applicable licenses. 
*/


define('RUAROBOT_VERSION', '1.0');
define('RUAROBOT_TOKEN', '<!--ruarobot-->');
define('RUAROBOT_DIR', dirname(__FILE__));
define('RUAROBOT_RAND', mt_rand(0, 10000000));
define('RUAROBOT_URL', 'http://www.isinc.com/wordpress/ruarobot/');

//start the session if it doesn't already exist...
if (!session_id()) {
	session_start();
}

function ruarobot_check_token() {
	global $user_ID;

	if (!$user_ID) {
		if (empty($_SESSION['ruarobot_keystring']) || !$_POST['ruarobot_value']) {
			return __('<strong>ОШИБКА</strong>: Вы должны ввести буквы и цифры с картинки.');
		}
		elseif ($_SESSION['ruarobot_invalid']) {
			return __('<strong>ОШИБКА</strong>: Вам необходимо обновить страницу, так как капча устарела.');
		}
		elseif ($_POST['ruarobot_value'] != strtolower($_SESSION['ruarobot_keystring'])) {
			$_SESSION['ruarobot_invalid'] = 1;
			return __('<strong>ОШИБКА</strong>: Неправильно введены цифры с картинки.');
		}
		else {
			unset($_SESSION['ruarobot_keystring']);
			unset($_SESSION['ruarobot_rnd']);
			unset($_SESSION['ruarobot_invalid']);
		}
	}
	return false;
}


/**
 * This function returns a URL which will play the captcha sound
 *
 * @param string $include_rand - You may want to generate the random value on your own, especially if you are using javascript.
 * @return string 
 * 
 */
function ruarobot_get_audio_url($include_rand=true) {
	return ruarobot_get_image_url($include_rand) . '&ruarobot_audio=1';	
}

/**
 * This function returns a URL which will display the captcha image
 *
 * @param string $include_rand - You may want to generate the random value on your own, especially if you are using javascript.
 * @return string 
 */
function ruarobot_get_image_url($include_rand=true) {
	$url = $_SERVER["REQUEST_URI"];
	if (FALSE !== strpos($url, '?')) {
		$url .= '&';
	}
	else {
		$url .= '?';
	}
	$url .= 'ruarobot_captcha=' . session_id();
	if ($include_rand) {
		$url .= '&ruarobot_rnd=' . RUAROBOT_RAND;
	}
	
	return $url;
}

//we need to override the wp_login function.  We can only do this if the function doesn't exist already.
if (get_option('ruarobot_login') && !function_exists('wp_login')) {
	//this is the same function that exists in the plugins folder.
	function wp_login($username, $password, $already_md5 = false) {
		global $wpdb, $error;
		$username = sanitize_user($username);
	
		if ( '' == $username )
			return false;
	
		if ( '' == $password ) {
			$error = __('<strong>ERROR</strong>: The password field is empty.');
			return false;
		}
	
		if (!$already_md5) {
			
			$error = ruarobot_check_token();
			if ($error) {
				return false;
			}
		}
	 	
	
		$login = get_userdatabylogin($username);
		//$login = $wpdb->get_row("SELECT ID, user_login, user_pass FROM $wpdb->users WHERE user_login = '$username'");
	
		if (!$login) {
			$error = __('<strong>ERROR</strong>: Invalid username.');
			return false;
		} else {
			// If the password is already_md5, it has been double hashed.
			// Otherwise, it is plain text.
			if ( ($already_md5 && md5($login->user_pass) == $password) || ($login->user_login == $username && $login->user_pass == md5($password)) ) {
				return true;
			} else {
				$error = __('<strong>ERROR</strong>: Incorrect password.');
				$pwd = '';
				return false;
			}
		}
	}
}

class ruarobot {
	
	var $error = "";

	function ruarobot() {
		
		add_action('init', array(&$this,'init'));
		add_action('admin_menu', array(&$this, 'admin_menu'));
		add_filter('comments_template', array(&$this,'comment'));
		add_action('preprocess_comment', array(&$this,'preprocess_comment'),1);
		add_action('wp_head', array(&$this,'head'));

		if (get_option('ruarobot_registration')) {
			add_action('register_form', array(&$this,'register_form'));
			add_action('register_post', array(&$this,'register_post'));
			add_filter('registration_errors', array(&$this,'registration_errors'));	
		}
		
		if (get_option('ruarobot_login')) {
			add_action('login_form', array(&$this,'login_form'));
		}
		
		
	}
		
	function login_form() {
		include(RUAROBOT_DIR . '/templates/login.php');
	}
	
	function register_form() {
		include(RUAROBOT_DIR . '/templates/login.php');
	}
	
	function registration_errors($arr) {
		if ($this->error) {
			$arr['user_login'] = $this->error;
		}
		return $arr;
	}
	
	function init() {
		if ($_GET['ruarobot_captcha'] == session_id()) {
			
			header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
			header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' );
			header( 'Cache-Control: no-store, no-cache, must-revalidate' );
			header( 'Cache-Control: post-check=0, pre-check=0', false );
			header( 'Pragma: no-cache' );  

			if($_GET['ruarobot_audio']) {
				if ($_SESSION['ruarobot_rnd'] == $_GET['ruarobot_rnd'] && !$_SESSION['ruarobot_invalid']) {
					header('Content-type: audio/mp3');
					header('Content-Disposition: attachment; filename=' . md5(session_id()) . '.mp3'); 
					$letters = str_split($_SESSION['ruarobot_keystring']);
					foreach ($letters as $letter) {
						readfile(RUAROBOT_DIR . '/audio/' . $letter . '.mp3');	
					}
					readfile(RUAROBOT_DIR . '/audio/silence.mp3');	
				}
			}
			else {
				include(RUAROBOT_DIR . '/kcaptcha/kcaptcha.php');
				
				$captcha = new KCAPTCHA();
				$_SESSION['ruarobot_keystring'] = $captcha->getKeyString();
				$_SESSION['ruarobot_rnd'] =  $_GET['ruarobot_rnd'];
				unset($_SESSION['ruarobot_invalid']);
			}
			die();
		}
	}
	
	function admin_menu() {
		 if ( function_exists('add_submenu_page') )
			add_submenu_page(
			'plugins.php',
			__('RUaRobot? Configuration Page'),
			__('RUaRobot?'),
			5,
			basename(__FILE__),
			array($this, 'admin_page')
		);
	}

	function is_open() {
		global $post;
		return ('open' == $post->comment_status);
	}

	function head() {
		global $user_ID;
		if ($this->is_open() && !$user_ID) {
			include(RUAROBOT_DIR . '/templates/header.php');
		}
	}	

	function admin_page() {
		include(RUAROBOT_DIR . '/templates/admin.php');
	}
				
	function register_post($data) {
		$this->error = ruarobot_check_token();
		if (!$this->error) {
			return $data;
		}
	}
		
	function preprocess_comment($commentdata) {
		$this->error = ruarobot_check_token();
		if ($this->error) {
			wp_die($this->error);
		}
		return $commentdata;
	}
	
	//capture the comment file before it is desplayed and replace the token.
	function comment($file) {
		global $user_ID;
		
		if ($this->is_open() && !$user_ID) {
			$contents = file_get_contents($file);
			//token doesn't exist, so we need to register for another event
			if (FALSE == stripos($contents, RUAROBOT_TOKEN)) {
				add_action('comment_form', array(&$this, 'comment_form'));
			}
			$newfile = RUAROBOT_DIR . '/ruarobot-comment.php';
			$_SESSION['ruarobot_comments_file'] = $file; 
			return $newfile; 	
		}
		else {
			return $file;
		}
	}
	
	//the token is our favorite way to display the contents... otherwise we'll just tag along
	//on the comment_form call.
	function comment_form($id) {
		include RUAROBOT_DIR . '/templates/comment.php';
	}
}


$ruarbot = new ruarobot();	
?>